---
title: XRRigidTransform
slug: Web/API/XRRigidTransform
tags:
  - API
  - AR
  - Interface
  - Reality
  - Reference
  - Reference Space
  - VR
  - Virtual
  - WebXR
  - WebXR API
  - WebXR Device API
  - XR
  - XRReferenceSpace
  - XRRigidTransform
  - augmented
  - space
  - transform
---
<p>{{APIRef("WebXR Device API")}}</p>

<p><span class="seoSummary">The <strong><code>XRRigidTransform</code></strong> is a <a href="/en-US/docs/Web/API/WebXR_API">WebXR API</a> interface that represents the 3D geometric transform described by a position and orientation.</span></p>

<p><code>XRRigidTransform</code> is used to specify transforms throughout the WebXR APIs, including:</p>

<ul>
 <li>The offset and orientation relative to the parent reference space to use when creating a new reference space with {{domxref("XRReferenceSpace.getOffsetReferenceSpace", "getOffsetReferenceSpace()")}}.</li>
 <li>The {{domxref("XRView.transform", "transform")}} of an {{domxref("XRView")}}.</li>
 <li>The {{domxref("XRPose.transform", "transform")}} of an {{domxref("XRPose")}}.</li>
 <li>The {{domxref("XRReferenceSpaceEvent")}} event's {{domxref("XRReferenceSpaceEvent.transform", "transform")}} property, as found in the {{domxref("XRReferenceSpace.reset_event", "reset")}} event received by an {{domxref("XRReferenceSpace")}}.</li>
</ul>

<p>The advantage to using <code>XRRigidTransform</code> in these places rather than bare arrays that providing the matrix data is that the <code>XRRigidTransform</code> automatically does things like computing the inverse of the transform. Even better, once it's been computed, it's cached so that subsequent requests are significantly faster.</p>

<h2 id="Constructor">Constructor</h2>

<dl>
 <dt>{{domxref("XRRigidTransform.XRRigidTransform", "new XRRigidTransform()")}}</dt>
 <dd>Creates a new <code>XRRigidTransform</code> object which represents a transform that applies a specified position and/or orientation.</dd>
</dl>

<h2 id="Properties">Properties</h2>

<dl>
 <dt>{{DOMxRef("XRRigidTransform.position")}} {{readonlyInline}} {{experimental_inline}}</dt>
 <dd>A {{DOMxRef("DOMPointReadOnly")}} specifying a 3-dimensional point, expressed in meters, describing the translation component of the transform. The {{DOMxRef("DOMPointReadonly.w", "w")}} property is always <code>1.0</code>.</dd>
 <dt>{{DOMxRef("XRRigidTransform.orientation")}} {{readonlyInline}} {{experimental_inline}}</dt>
 <dd>A {{DOMxRef("DOMPointReadOnly")}} which contains a unit quaternion describing the rotational component of the transform. As a unit quaternion, its length is always normalized to <code>1.0</code>.</dd>
 <dt>{{DOMxRef("XRRigidTransform.matrix")}} {{readonlyInline}} {{experimental_inline}}</dt>
 <dd>Returns the transform matrix in the form of a 16-member {{DOMxRef("Float32Array")}}. See the section <a href="/en-US/docs/Web/API/XRRigidTransform/matrix#Matrix_format">Matrix format</a> for how the array is used to represent a matrix.</dd>
</dl>

<dl>
 <dt>{{DOMxRef("XRRigidTransform.inverse")}} {{readonlyInline}} {{experimental_inline}}</dt>
 <dd>Returns a <code>XRRigidTransform</code> which is the inverse of this transform. That is, if applied to an object that had been previously transformed by the original transform, it will undo the transform and return the original object.</dd>
</dl>

<h2 id="Usage_notes">Usage notes</h2>

<p>When an <code>XRRigidTransform</code> is interpreted, the orientation is always applied to the affected object before the position is applied.</p>

<h2 id="Example">Example</h2>

<p>This code snippet creates an <code>XRRigidTransform</code> to specify the offset and orientation in relation to the current reference space to use when creating a new reference space. It then requests the first animation frame callback by calling the session's {{domxref("XRSession.requestAnimationFrame", "requestAnimationFrame()")}} method.</p>

<pre class="brush: js notranslate">xrSession.requestReferenceSpace(refSpaceType)
.then((refSpace) =&gt; {
  xrReferenceSpace = refSpace;
  xrReferenceSpace = xrReferenceSpace.getOffsetReferenceSpace(
        new XRRigidTransform(viewerStartPosition, cubeOrientation));
  animationFrameRequestID = xrSession.requestAnimationFrame(drawFrame);</pre>

<h2 id="Specifications">Specifications</h2>

<table class="standard-table">
 <thead>
  <tr>
   <th scope="col">Specification</th>
   <th scope="col">Status</th>
   <th scope="col">Comment</th>
  </tr>
 </thead>
 <tbody>
  <tr>
   <td>{{SpecName("WebXR","#xrrigidtransform-interface","XRRigidTransform")}}</td>
   <td>{{Spec2("WebXR")}}</td>
   <td>Initial definition.</td>
  </tr>
 </tbody>
</table>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<div>{{Compat("api.XRRigidTransform")}}</div>
